/* FLEXBOX */
/* Flexbox Playground: https://codepen.io/osublake/full/dMLQJr */

* { box-sizing: border-box; }

html {
  font-family: sans-serif;
  font-size: 16px;
  margin: 0;
  padding: 0;
}

body {

}

.monotype {
  font-family: monospace;
  background-color: khaki;
  padding: 4px 8px;
  border-radius: 4px;
}

.flex-container {
  background-color: grey;
  display: block;
  margin-bottom: 40px;
  padding: 5px;
}

  .flex-item {
    font-size: 20px;
    line-height: 100px;
    text-align: center;
    background-color: orange;
    border-radius: 4px;
    width: 100px;
    margin: 10px;
  }

  .flex-item:nth-child(5n - 4) { background-color: #2a80b9; }
  .flex-item:nth-child(5n - 3) { background-color: #8f44ad; }
  .flex-item:nth-child(5n - 2) { background-color: #16a086; }
  .flex-item:nth-child(5n - 1) { background-color: #f1c40f; }
  .flex-item:nth-child(5n) { background-color: #e77e23; }


/* CONTENEDOR FLEXBOX */

/* 1. display:flex */

.flex-container { display: flex; }


/* 2. flex-direction */

.flex-direction {
  flex-direction: row; /* Valor por defecto */
  /* flex-direction: row-reverse; */
  /* flex-direction: column; */
  /* flex-direction: column-reverse; */
}


/* 3. flex-wrap */

.flex-wrap {
  width: 400px; /* Estrechamos contenedor para ver su efecto */
  flex-wrap: nowrap;  /* Valor por defecto */
  /* flex-wrap: wrap; */
  /* flex-wrap: wrap-reverse; */
}


/* 4. flex-flow */

.flex-flow {
  width: 400px; /* Estrechamos contenedor para ver su efecto */
  flex-flow: row nowrap; /* Valor por defecto */
  /* flex-flow: row-reverse wrap-reverse; */
  /* flex-flow: column wrap-reverse; */
  /* flex-flow: column-reverse wrap-reverse; */
}


/* 5. justify-content */

.justify-content {
  justify-content: flex-start; /* Valor por defecto */
  /* justify-content: flex-end; */
  /* justify-content: center; */
  /* justify-content: space-between; */
  /* justify-content: space-around; */
  /* justify-content: space-evenly; */
}


/* 6. align-items */

.align-items {
  align-items: stretch; /* Valor por defecto */
  /* align-items: flex-start; */
  /* align-items: flex-end; */
  /* align-items: center; */
  /* align-items: baseline; */
}

  .align-items .flex-item:nth-child(3) {
    font-size: 40px;
  }


/* 7. align-content */

.align-content {
  height: 600px; /* Fijamos una altura mayor en el contenedor para ver su efecto */
  flex-wrap: wrap;  /* Necesario para ver su efecto */
  align-content: stretch; /* Valor por defecto */
  /* align-content: flex-start; */
  /* align-content: flex-end; */
  /* align-content: center; */
  /* align-content: space-between; */
  /* align-content: space-around; */
  /* align-content: space-evenly; */
}


/* ELEMENTOS FLEXBOX */

/* 1. order */

.order .flex-item:nth-child(1) { order: 2; }
.order .flex-item:nth-child(2) { order: 3; }
.order .flex-item:nth-child(3) { order: 4; }
.order .flex-item:nth-child(4) { order: 5; }
.order .flex-item:nth-child(5) { order: 1; }


/* 2. flex-grow */

.flex-grow .flex-item:nth-child(1) { flex-grow: 1; }
.flex-grow .flex-item:nth-child(2) { flex-grow: 2; }
.flex-grow .flex-item:nth-child(3) { flex-grow: 3; }
.flex-grow .flex-item:nth-child(4) { flex-grow: 2; }
.flex-grow .flex-item:nth-child(5) { flex-grow: 1; }


/* 3. flex-shrink */

.flex-shrink {
  width: 400px; /* Estrechamos contenedor para ver su efecto */
}

.flex-shrink .flex-item:nth-child(1) { flex-shrink: 1; }
.flex-shrink .flex-item:nth-child(2) { flex-shrink: 2; }
.flex-shrink .flex-item:nth-child(3) { flex-shrink: 3; }
.flex-shrink .flex-item:nth-child(4) { flex-shrink: 2; }
.flex-shrink .flex-item:nth-child(5) { flex-shrink: 1; }


/* 4. flex-basis */

.flex-basis .flex-item:nth-child(1) { flex-basis: 5%; }
.flex-basis .flex-item:nth-child(2) { flex-basis: 25%; }
.flex-basis .flex-item:nth-child(3) { flex-basis: 40%; }
.flex-basis .flex-item:nth-child(4) { flex-basis: 25%; }
.flex-basis .flex-item:nth-child(5) { flex-basis: 5%; }


/* 5. flex */

.flex .flex-item:nth-child(1) { flex: 1 2 100px; }
.flex .flex-item:nth-child(2) { flex: 2 1 100px; }
.flex .flex-item:nth-child(3) { flex: 1 2 200px; }
.flex .flex-item:nth-child(4) { flex: 2 1 100px; }
.flex .flex-item:nth-child(5) { flex: 1 2 100px; }


/* 6. align-self */

.align-self {
  height: 400px; /* Estrechamos contenedor para ver su efecto */
}

.align-self .flex-item:nth-child(3) {
  font-size: 40px;
}

.align-self .flex-item:nth-child(3) {
  align-self: stretch;
  /* align-self: flex-start; */
  /* align-self: flex-end; */
  /* align-self: center; */
  /* align-self: baseline; */
}

/* .align-self .flex-item:nth-child(1) { align-self: flex-start; }
.align-self .flex-item:nth-child(2) { align-self: flex-end; }
.align-self .flex-item:nth-child(3) { align-self: center; }
.align-self .flex-item:nth-child(4) { align-self: baseline; }
.align-self .flex-item:nth-child(5) { align-self: stretch; } */

